#include <stdio.h>
#include <math.h>
#include <GL/glut.H>

//f[^
int W, H; //Əc̃f[^
float f[1000][1000]; //l2z. Kɑ傫ȗ̈ƂĂ
float h; //f[^̏c̊Ԋu

//ȉ͌vẐ߂ɕKvȔz
int edge[1000][1000]; //GbW`߂̃f[^ (1 ̂ƂGbW)
int convex[1000][1000]; //ʂ̕`߂̃f[^ (1̂ƂʁC0Ȃ牚, 2Ȃƌ^D-1 ͕Ȃ)

//ȉ͉ۑ6-3̂
float tmp[1000][1000]; //̂߂̈ꎞL̈
float dx[1000][1000]; //Canny GbWô߂̈ꎞL̈ (x̔)
float dy[1000][1000]; //Canny GbWô߂̈ꎞL̈ (y̔)
float gl[1000][1000]; //Canny GbWô߂̈ꎞL̈ (z̒)

float maxVal = 0.25; //XP[lŌڂ̂̂łBłڂƊ珬ύX


//ۑ2-3 (㉺])
void flipUpDown(){
  //2d[vŏ㉺𔽓]B
  //f[^0`1܂łƂB܂ 01, 10 ƂȂ΂悢
  //f[j][i]  (j, i) ɑΉ邱Ƃɏ\ !!!
  
  for(int j=0; j<H; j++){
    for(int i=0; i<W; i++){
      f[j][i] = 1.0 - f[j][i];
    }
  }
}


//ۑ3-3 (GbWo)
void detectEdge(){
  //zvZāAKȒl傫
  //edge[i]  1 
  
  for(int j=1; j<H-1; j++){
    for(int i=1; i<W-1; i++){
      float gx = (f[j][i+1]-f[j][i-1])/(2.0*h);
      float gy = (f[j+1][i]-f[j-1][i])/(2.0*h);
      if(sqrt(gx*gx + gy*gy) > 10)
        edge[j][i] = 1;
      else
        edge[j][i] = 0;
    }
  }
}


//ۑ4-2 ()
void smooth(){
  //for ŏ㉺E̒l̕ϒl temp[j][i] ֑ĂA
  //I V for  tmp[j][i]  f[j][i] ֑
  
  for(int j=1; j<H-1; j++)
    for(int i=1; i<W-1; i++)
      tmp[j][i] = 0.25f*(f[j][i+1]+f[j][i-1]+f[j+1][i]+f[j-1][i]);
  
  for(int j=1; j<H-1; j++)
    for(int i=1; i<W-1; i++)
      f[j][i] = tmp[j][i];
}


//ۑ5-2 (GbWۑ)
void adaptiveSmooth(){
  //for ŏ㉺E̒l̕ϒl temp[j][i] ֑ĂA
  //I V for  tmp[j][i]  f[j][i] ֑
  float s = 1/(h*h); //p[^
  
  for(int j=1; j<H-1; j++)
    for(int i=1; i<W-1; i++){
      float w1 = 1.0/(1.0 + s*pow(f[j][i+1]-f[j][i],2));
      float w2 = 1.0/(1.0 + s*pow(f[j][i-1]-f[j][i],2));
      float w3 = 1.0/(1.0 + s*pow(f[j+1][i]-f[j][i],2));
      float w4 = 1.0/(1.0 + s*pow(f[j-1][i]-f[j][i],2));
      tmp[j][i] = (w1*f[j][i+1]+w2*f[j][i-1]+w3*f[j+1][i]+w4*f[j-1][i])/(w1+w2+w3+w4);
    }
  
  for(int j=1; j<H-1; j++)
    for(int i=1; i<W-1; i++)
      f[j][i] = tmp[j][i];
}


//ۑ6-3  ۑ6-4 (Canny GbWo)
void CannyEdgeDetector(){
  //܂1ڂ̃[v dx[j][i], dy[j][i] ֌zxNg@dl[i][j] ֒
  //, 2ڂ̃[vŃGbW̔B(GbWȂ edge[i]  1 )
  
  for(int j=1; j<H-1; j++)
    for(int i=1; i<W-1; i++){
      dx[j][i] = (f[j][i+1]-f[j][i-1])/(2.0*h);
      dy[j][i] = (f[j+1][i]-f[j-1][i])/(2.0*h);
      gl[j][i] = sqrt(dx[j][i]*dx[j][i]+dy[j][i]*dy[j][i]);
    }
  
  for(int j=2; j<H-2; j++)
    for(int i=2; i<W-2; i++){
      float a = dy[j][i]/dx[j][i]; //̌X
      if(fabs(a) < 1){ //Ō
        if(a > 0){ //E͏A͉
          if((1-a)*gl[j][i+1] + a*gl[j+1][i+1] < gl[j][i] &&
             (1-a)*gl[j][i-1] + a*gl[j-1][i-1] < gl[j][i])
            edge[j][i] = 1;
          else
            edge[j][i] = 0;
        }
        else{ //E͉A͏
          if((1+a)*gl[j][i+1] - a*gl[j-1][i+1] < gl[j][i] &&
             (1+a)*gl[j][i-1] - a*gl[j+1][i-1] < gl[j][i])
            edge[j][i] = 1;
          else
            edge[j][i] = 0;
        }
      }
      else{ //cŌ
        a = dx[j][i]/dy[j][i];
        if(a > 0){ //͉EA͍
          if((1-a)*gl[j+1][i] + a*gl[j+1][i+1] < gl[j][i] &&
             (1-a)*gl[j-1][i] + a*gl[j-1][i-1] < gl[j][i])
            edge[j][i] = 1;
          else
            edge[j][i] = 0;
        }
        else{ //͍A͉E
          if((1+a)*gl[j+1][i] - a*gl[j+1][i-1] < gl[j][i] &&
             (1+a)*gl[j-1][i] - a*gl[j-1][i+1] < gl[j][i])
            edge[j][i] = 1;
          else
            edge[j][i] = 0;
        }
      }
    }
}


//ۑ7-2 (ʂ̔)
void segment(){
  //wVA g[X  s񎮂vZA 62 y[W
  //@Ȃ convex[j][i]  0 
  //AȂ convex[j][i]  1 
  //BȂ convex[j][i]  2 
  //̑Ȃ convex[j][i]  -1 
  
  for(int j=1; j<H-1; j++){
    for(int i=1; i<W-1; i++){
      float xx = f[j][i+1] + f[j][i-1] - 2.0*f[j][i];
      float yy = f[j+1][i] + f[j-1][i] - 2.0*f[j][i];
      float xy = 0.25f*(f[j+1][i+1] + f[j-1][i-1] - f[j+1][i-1] - f[j-1][i+1]);
      if(xx*yy - xy*xy < 0)
        convex[j][i] = 2;
      else if(xx + yy > 0)
        convex[j][i] = 0;
      else if(xx + yy < 0)
        convex[j][i] = 1;
      else
        convex[j][i] = -1;
    }
  }
}

/************ ͉̉ۑɂ͊֌ŴȂ֐ (݂ȂĂ悢) *****************/

//]̂߂̕ϐ
int mouseX, mouseY;
float qw, qx, qy, qz;
float zoom;
float shiftX, shiftY;
bool wire;
bool color;
int width, height;

//t@Clǂݍފ֐
void readValues(char* file_name){
  
  FILE* in;
  fopen_s(&in, file_name, "r");
  
  fscanf_s(in, "%d", &W);
  fscanf_s(in, "%d", &H);
  
  for(int j=0; j<H; j++)
    for(int i=0; i<W; i++){
      fscanf_s(in, "%f", &f[j][i]);
      edge[j][i] = 0;
      convex[j][i] = -1;
    }
  
  fclose(in);
  
  h = 1.0/(W-1);
}

//lӌ`̖@̌vZ֐ (ڍׂ̓|SbV̉)
void newell(float n[3], float (*v)[3], int N){
  n[0] = n[1] = n[2] = 0;
  for(int i=0; i<N; i++){
    float* p = v[i];
    float* q = v[(i+1)%N];
    n[0] += (p[1]-q[1])*(p[2]+q[2]);
    n[1] += (p[2]-q[2])*(p[0]+q[0]);
    n[2] += (p[0]-q[0])*(p[1]+q[1]);
  }
  float l = (float)sqrt(n[0]*n[0]+n[1]*n[1]+n[2]*n[2]);
  if(l != 0){
    n[0] /= l;
    n[1] /= l;
    n[2] /= l;
  }
}

//Cgʂč\
void shading(){
  glPolygonMode(GL_FRONT, GL_FILL);
  glShadeModel(GL_FLAT);
  glEnable(GL_LIGHTING);
  
  for(int j=0; j<H-1; j++){
    for(int i=0; i<W-1; i++){
      float v[4][3] = {
        {i*h-0.5, j*h-0.5, maxVal*(f[j][i]-0.5)},
        {(i+1)*h-0.5, j*h-0.5, maxVal*(f[j][i+1]-0.5)},
        {(i+1)*h-0.5, (j+1)*h-0.5, maxVal*(f[j+1][i+1]-0.5)},
        {i*h-0.5, (j+1)*h-0.5, maxVal*(f[j+1][i]-0.5)}
      };
      float n[3];
      newell(n, v, 4);
      glBegin(GL_POLYGON);
        glNormal3fv(n);
        glVertex3fv(v[0]);
        glVertex3fv(v[1]);
        glVertex3fv(v[2]);
        glVertex3fv(v[3]);
      glEnd();
    }
  }
}

//ق𔒂ŕ\
void coloring(){
  glPolygonMode(GL_FRONT, GL_FILL);
  glDisable(GL_LIGHTING);
  
  for(int j=0; j<H-1; j++){
    for(int i=0; i<W-1; i++){
      glBegin(GL_POLYGON);
        float v = f[j][i];
        glColor3f(v, v, v);
        glVertex3f(i*h-0.5, j*h-0.5, maxVal*(v-0.5));
        
        v = f[j][i+1];
        glColor3f(v, v, v);
        glVertex3f((i+1)*h-0.5, j*h-0.5, maxVal*(v-0.5));
        
        v = f[j+1][i+1];
        glColor3f(v, v, v);
        glVertex3f((i+1)*h-0.5, (j+1)*h-0.5, maxVal*(v-0.5));
        
        v = f[j+1][i];
        glColor3f(v, v, v);
        glVertex3f(i*h-0.5, (j+1)*h-0.5, maxVal*(v-0.5));
      glEnd();
    }
  }
}

//GbWԂ_Ƃĕ`֐
void drawEdge(){
  glPolygonMode(GL_FRONT, GL_LINE);
  glDisable(GL_LIGHTING);
  
  glColor3f (1, 0, 0);
  glPointSize(5);
  
  glBegin(GL_POINTS);
  for(int j=0; j<H; j++){
    for(int i=0; i<W; i++){
      if(edge[j][i] == 1)
        glVertex3f(i*h-0.5, j*h-0.5, maxVal*(f[j][i]-0.5));
    }
  }
  glEnd();
}

//Ȗʂ̉ʂ_̐Fŕ`֐
void drawSegment(){
  glPolygonMode(GL_FRONT, GL_LINE);
  glDisable(GL_LIGHTING);
  
  glPointSize(5);
  glBegin(GL_POINTS);
  for(int j=0; j<H; j++){
    for(int i=0; i<W; i++){
      if(convex[j][i] == -1)
        continue;
      
      if(convex[j][i] == 1)
        glColor3f(1, 1, 0);
      else if(convex[j][i] == 0)
        glColor3f(0, 1, 1);
      else if(convex[j][i] == 2)
        glColor3f(1, 0, 1);
      glVertex3f(i*h-0.5, j*h-0.5, maxVal*(f[j][i]-0.5));
    }
  }
  glEnd();
}

//אڂ\Fŕ\
void drawWire(){
  glPolygonMode(GL_FRONT, GL_LINE);
  glDisable(GL_LIGHTING);
  
  glColor3f (1.0, 1.0, 0.0);
  glLineWidth(1.0f);
  
  for(int j=0; j<H-1; j++){
    for(int i=0; i<W-1; i++){
      glBegin(GL_POLYGON);
        glVertex3f(i*h-0.5, j*h-0.5, maxVal*(f[j][i]-0.5));
        glVertex3f(i*h-0.5, (j+1)*h-0.5, maxVal*(f[j+1][i]-0.5));
        glVertex3f((i+1)*h-0.5, (j+1)*h-0.5, maxVal*(f[j+1][i+1]-0.5));
        glVertex3f((i+1)*h-0.5, j*h-0.5, maxVal*(f[j][i+1]-0.5));
      glEnd();
    }
  }
}

void display(void){ 
  //XN[ƕϊs
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 
  glLoadIdentity();
  
  //]Ȃǂ̕ϊ
  glTranslatef(shiftX, shiftY, 0);
  float s = (float)sqrt(qx*qx + qy*qy + qz*qz);
  if(s != 0)
    glRotatef(2.0f*(float)acos(qw)*180/3.1412f, qx/s, qy/s,qz/s);
  
  //f[^̕`
  if(color)
    coloring(); //f[^` (F)
  else
    shading(); //f[^` ()
  
  if(wire)
    drawWire(); //`Ԃ̐
  
  drawEdge(); //f[^`
  drawSegment(); //GbW`
  
  //XN[XV
  glFlush(); 
  glutSwapBuffers(); 
} 


void myinit(){
  GLfloat mat_specular[]={0.5, 0.5, 0.5, 1.0};
  GLfloat mat_diffuse[]={0.5, 0.5, 1.0, 1.0};
  GLfloat mat_ambient[]={0.5, 0.5, 0.5, 1.0}; 
  GLfloat mat_shininess={20.0};
  GLfloat light_ambient[]={0.1, 0.1, 0.1, 1.0};
  GLfloat light_diffuse[]={1.0, 1.0, 1.0, 1.0};
  GLfloat light_specular[]={1.0, 1.0, 1.0, 1.0};
  
  /* set up ambient, diffuse, and specular components for light 0 */
  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
  
  /* define material proerties for front face of all polygons */
  glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
  glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
  glMaterialf(GL_FRONT, GL_SHININESS, mat_shininess);
  
  glShadeModel(GL_SMOOTH);   /* smooth shading */
  glEnable(GL_LIGHTING); /* enable lighting */
  glEnable(GL_LIGHT0);   /* enable light 0 */
  glEnable(GL_DEPTH_TEST); /* enable z buffer */
  glDepthFunc(GL_LEQUAL);
  
  glClearColor (1.0, 1.0, 1.0, 1.0);
}

void myReshape(int w, int h){
  width = w;
  height = h;
  
  glViewport(0, 0, w, h); 
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity(); 
  if (w <= h) 
    glOrtho(-0.5/zoom, 0.5/zoom,
            -0.5*h/w/zoom, 0.5*h/w/zoom,
            -100.0, 100.0); 
  else 
    glOrtho(-0.5*w/h/zoom, 0.5*w/h/zoom,
            -0.5/zoom, 0.5/zoom,
            -100.0, 100.0);
  gluLookAt(0,0,-10, 0,0,0, 0,-1,0);
  glMatrixMode(GL_MODELVIEW); 
} 

void mouse(int btn, int state, int x, int y){ 
  /* mouse callback, selects an axis about which to rotate */
  if(state == GLUT_DOWN){
    mouseX = x;
    mouseY = y;
  }
  else if(btn==GLUT_LEFT_BUTTON){
    float mx = -0.0025f*(x - mouseX)/zoom;
    float my = 0.0025f*(y - mouseY)/zoom;
    
    //rotation
    float c = (float)cos(my);
    float s = (float)sin(my);
    
    float rw = c*qw - s*qx;
    float rx = c*qx + s*qw;
    float ry = c*qy - s*qz;
    float rz = c*qz + s*qy;
    
    c = (float)cos(mx);
    s = (float)sin(mx);
    
    qw = c*rw - s*ry;
    qx = c*rx + s*rz;
    qy = c*ry + s*rw;
    qz = c*rz - s*rx;
    
    float n = (float)sqrt(qw*qw + qx*qx + qy*qy + qz*qz);
    if(n != 0){
      qw /= n;
      qx /= n;
      qy /= n;
      qz /= n;
    }
    else{
      qw = 1.0f;
      qx = qy = qz = 0.0f;
    }
    display();
  }
  else if(btn==GLUT_RIGHT_BUTTON){
    zoom -= 0.0025f*(y - mouseY);
    if(zoom > 20.0f) zoom = 20.0f;
    else if(zoom < 0.05f) zoom = 0.05f;
    myReshape(width, height);
    display();
  }
  else if(btn==GLUT_MIDDLE_BUTTON){
    shiftX += 0.0025f*(x - mouseX)/zoom;
    shiftY += 0.0025f*(y - mouseY)/zoom;
    display();
  }
} 

void keyboard(unsigned char key, int x, int y){
  switch (key) {
  case 'w':
    wire = !wire;
    display();
    break;
  case 'c':
    color = !color;
    display();
    break;
  case 'f':
    printf("㉺]\n");
    flipUpDown();
    display();
    break;
  case 's':
    printf("\n");
    smooth();
    display();
    break;
  case 'a':
    printf("GbWۑ\n");
    adaptiveSmooth();
    display();
    break;
  case 'e':
    printf("GbWo\n");
    detectEdge();
    display();
    break;
  case 'n':
    printf("Cannyo\n");
    CannyEdgeDetector();
    display();
    break;
  case 'h':
    printf("\n");
    segment();
    display();
    break;
  }
}


/**********************ȂƂ悢Ƃ낱܂***********************/

int main(int argc, char** argv){
  //ۑ 2-2 ǂݍ߂f[^ "lena", "wave", "engine", "range", "dump"
  readValues("data/lena");
  //ۑ7  wave  dump pčs
  
  //]Ȃǂ̏
  qw = 1;
  qx = qy =  qz = 0;
  zoom = 1;
  shiftX = shiftY = 0;
  wire = false;
  color = true;
  
  //EBhȄ
  glutInit(&argc, argv); 
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH); //gpobt@̐ݒ
  glutInitWindowSize(500, 500); //EBhȆ傫
  glutCreateWindow("prog2-2"); //EBhẼ^Cg
  
  myinit(); //OpenGL ̏
  glutReshapeFunc(myReshape); //EBhETCYύXꂽɌĂ΂֐ݒ
  glutDisplayFunc(display);  //EBhE̍XV̂߂̊֐ݒ
  glutMouseFunc(mouse); //}EX삳ꂽƂɌĂ΂֐ݒ
  glutKeyboardFunc(keyboard);//L[{[hꂽƂɌĂ΂֐ݒ
  
  glutMainLoop(); //C[v
  
  return 0;
}

